• Winter-2-STL-C Where is the Marble? 解题报告及测试数据


    Time Limit:3000MS     Memory Limit:0KB
    Description
    Download as PDF
    Raju and Meena love to play with Marbles. They have got a lot of marbles with numbers written on them. At the beginning, Raju would place the marbles one after another in ascending order of the numbers written on them. Then Meena would ask Raju to find the first marble with a certain number. She would count 1...2...3. Raju gets one point for correct answer, and Meena gets the point if Raju fails. After some fixed number of trials the game ends and the player with maximum points wins. Today it's your chance to play as Raju. Being the smart kid, you'd be taking the favor of a computer. But don't underestimate Meena, she had written a program to keep track how much time you're taking to give all the answers. So now you have to write a program, which will help you in your role as Raju.
    Input
    There can be multiple test cases. Total no of test cases is less than 65. Each test case consists begins with 2 integers: N the number of marbles and Q the number of queries Mina would make. The next N lines would contain the numbers written on the N marbles. These marble numbers will not come in any particular order. Following Q lines will have Q queries. Be assured, none of the input numbers are greater than 10000 and none of them are negative.
    Input is terminated by a test case where N = 0 and Q = 0.
    Output
    For each test case output the serial number of the case.
    For each of the queries, print one line of output. The format of this line will depend upon whether or not the query number is written upon any of the marbles. The two different formats are described below:
    `x found at y', if the first marble with number x was found at position y. Positions are numbered 1, 2,..., N.
    `x not found', if the marble with number x is not present.
    Look at the output for sample input for details.
    Sample Input
    4 1
    2
    3
    5
    1
    5
    5 2
    1
    3
    3
    3
    1
    2
    3
    0 0
    Sample Output
    CASE# 1:
    5 found at 4
    CASE# 2:
    2 not found
    3 found at 3

    题解:由于数据量只有10000,暴力求解即可。先进行排序,然后使用lower_bound()函数寻找位置即可。     

    以下是代码: 

    #include <iostream>
    #include <cstdio>
    #include <vector>
    #include <stack>
    #include <cstring>
    #include <algorithm>
    using namespace std;
    int a[10005];
    int main()
    {
        //freopen("1.in","r",stdin);
        int N,Q,t,p;
        int k=0;
        while(scanf("%d%d",&N,&Q)!=EOF && (N || Q)){
            for(int i=0;i<N;i++)
                scanf("%d",&a[i]);
            sort(a,a+N);//排序
            printf("CASE# %d:
    ",++k);
            while(Q--){
                scanf("%d",&t);
                p = lower_bound(a,a+N,t)-a;//小于等于t的最初位置
                if(a[p]==t){//存在,则输出
                    printf("%d found at %d
    ",t,p+1);
                }else printf("%d not found
    ",t);
            }
        }
    }
    

      

  • 相关阅读:
    golang书签
    linux每日知识整理
    leetcode动态规划笔记五---双序列型
    leetcode动态规划笔记三---单序列型
    leetcode动态规划笔记二---矩阵型DP
    leetcode动态规划笔记一---一维DP
    linux系统IO操作
    golang知识精要(二)
    ubuntu修改键盘键位映射
    Python 使用 cx_Oracle 第三方库连接操作Oracle数据库
  • 原文地址:https://www.cnblogs.com/gzdaijie/p/4298736.html
Copyright © 2020-2023  润新知